<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="公司编码" prop="companyCode">
              <el-input v-model="queryParams.companyCode" placeholder="请输入公司编码" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="公司名称" prop="companyName">
              <el-input v-model="queryParams.companyName" placeholder="请输入公司名称" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>
    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="22"><span>公司信息列表</span> </el-col>
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['system:company:add']">新增</el-button>
          </el-col>
        </el-row>
      </template>
      <el-table v-loading="loading" border :data="companyList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="编号" align="center" prop="companyCode" />
        <el-table-column label="企业名称" align="left" prop="companyName" min-width="180" />
        <el-table-column label="成立日期" align="center" prop="foundDate" width="180">
          <template #default="scope">
            <span>{{ parseTime(scope.row.foundDate, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="法人代表" align="center" prop="corporation" />
        <el-table-column label="办公电话" align="center" prop="phone" />
        <el-table-column label="公司地址" align="center" prop="address" />
        <el-table-column label="状态" align="center" prop="isShow">
          <template #default="scope">
            <el-switch v-model="scope.row.isShow" active-value="0" inactive-value="1" @change="handleStatusChange(scope.row)"></el-switch>
          </template>
        </el-table-column>
        <!-- <el-table-column label="数据来源" align="center" prop="dataSource" /> -->
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:company:edit']">编辑</el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
  </div>
</template>

<script setup name="Company" lang="ts">
import { listCompany, getCompany, delCompany, addCompany, updateCompany, changeShowStatus } from '@/api/company/company';
import { CompanyVO, CompanyQuery, CompanyForm } from '@/api/company/company/types';
const router = useRouter();

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { sys_platform_yes_no } = toRefs<any>(proxy?.useDict('sys_platform_yes_no'));

const companyList = ref<CompanyVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const companyFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: CompanyForm = {
  id: undefined,
  accBnId: undefined,
  accBnNo: undefined,
  address: undefined,
  begDate: undefined,
  busScp: undefined,
  capAmt: undefined,
  companyFullName: undefined,
  corporation: undefined,
  email: undefined,
  endDate: undefined,
  foundDate: undefined,
  inCustId: undefined,
  inSupId: undefined,
  lelPer: undefined,
  phone: undefined,
  principal: undefined,
  regAddr: undefined,
  regDate: undefined,
  regOrg: undefined,
  taxNo: undefined,
  companyCode: undefined,
  companyName: undefined,
  isShow: undefined,
  dataSource: undefined,
  status: undefined,
  remark: undefined
};
const data = reactive<PageData<CompanyForm, CompanyQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    accBnId: undefined,
    accBnNo: undefined,
    address: undefined,
    begDate: undefined,
    busScp: undefined,
    capAmt: undefined,
    companyFullName: undefined,
    corporation: undefined,
    email: undefined,
    endDate: undefined,
    foundDate: undefined,
    inCustId: undefined,
    inSupId: undefined,
    lelPer: undefined,
    phone: undefined,
    principal: undefined,
    regAddr: undefined,
    regDate: undefined,
    regOrg: undefined,
    taxNo: undefined,
    companyCode: undefined,
    companyName: undefined,
    isShow: undefined,
    dataSource: undefined,
    status: undefined,
    platformCode: undefined,
    params: {}
  },
  rules: {
    address: [{ required: true, message: '公司地址不能为空', trigger: 'blur' }],
    endDate: [{ required: true, message: '经营结束日期不能为空', trigger: 'blur' }],
    foundDate: [{ required: true, message: '成立日期不能为空', trigger: 'blur' }],
    regDate: [{ required: true, message: '注册日期不能为空', trigger: 'blur' }],
    companyName: [{ required: true, message: '公司名称不能为空', trigger: 'blur' }],
    isShow: [{ required: true, message: '是否显示不能为空', trigger: 'change' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询公司信息列表 */
const getList = async () => {
  loading.value = true;
  const res = await listCompany(queryParams.value);
  companyList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  companyFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: CompanyVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

const handleStatusChange = async (row: CompanyVO) => {
  const oldValue = row.isShow; // 保存旧值（0 或 1）

  try {
    await changeShowStatus(row.id, row.isShow); // 传新值
    proxy?.$modal.msgSuccess('操作成功');
  } catch {
    row.isShow = oldValue; // 失败回滚
    proxy?.$modal.msgError('操作失败，请重试');
  }
};

/** 新增按钮操作 */
const handleAdd = () => {
  router.push({
    path: '/company/company-add'
  });
};

/** 修改按钮操作 */
const handleUpdate = async (row?: CompanyVO) => {
  const _id = row?.id || ids.value[0];
  router.push({ path: '/company/company-add', query: { id: _id } });
};

/** 提交按钮 */
const submitForm = () => {
  companyFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateCompany(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addCompany(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: CompanyVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除公司信息编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delCompany(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'system/company/export',
    {
      ...queryParams.value
    },
    `company_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});
onActivated(() => {
  getList();
});
</script>
